import { SvelteComponent, init, safe_not_equal, element, attr, toggle_class, listen, insert, noop, detach, binding_callbacks } from 'svelte/internal';
import { onMount } from 'svelte';

/* src/index.svelte generated by Svelte v3.6.5 */

function create_fragment(ctx) {
	var img, dispose;

	return {
		c() {
			img = element("img");
			attr(img, "src", ctx.path);
			attr(img, "alt", ctx.alt);
			attr(img, "class", "svelte-lazy-image");
			toggle_class(img, "svelte-lazy-image--loaded", ctx.loaded);
			dispose = listen(img, "load", ctx.handleLoad);
		},

		m(target, anchor) {
			insert(target, img, anchor);
			ctx.img_binding(img);
		},

		p(changed, ctx) {
			if (changed.path) {
				attr(img, "src", ctx.path);
			}

			if (changed.alt) {
				attr(img, "alt", ctx.alt);
			}

			if (changed.loaded) {
				toggle_class(img, "svelte-lazy-image--loaded", ctx.loaded);
			}
		},

		i: noop,
		o: noop,

		d(detaching) {
			if (detaching) {
				detach(img);
			}

			ctx.img_binding(null);
			dispose();
		}
	};
}

function instance($$self, $$props, $$invalidate) {
	let observerCallback = function(entries, observer) {
    entries.forEach(entry => {
      if (entry.isIntersecting) {
        $$invalidate('intersected', intersected = true);
        observer.unobserve(imgElement);
      }
    });
  };

  let { placeholder, src, alt } = $$props;

  let imgElement;
  let path;

  let observer;
  let intersected = false;
  let loaded = false;

  onMount(() => {
    observer = new IntersectionObserver(observerCallback);
    observer.observe(imgElement);

    return () => {
      observer.unobserve(imgElement);
    };
  });

  function handleLoad() {
    if (!loaded && path === src) {
      $$invalidate('loaded', loaded = true);
    }
  }

	function img_binding($$value) {
		binding_callbacks[$$value ? 'unshift' : 'push'](() => {
			$$invalidate('imgElement', imgElement = $$value);
		});
	}

	$$self.$set = $$props => {
		if ('placeholder' in $$props) $$invalidate('placeholder', placeholder = $$props.placeholder);
		if ('src' in $$props) $$invalidate('src', src = $$props.src);
		if ('alt' in $$props) $$invalidate('alt', alt = $$props.alt);
	};

	$$self.$$.update = ($$dirty = { intersected: 1, src: 1, placeholder: 1 }) => {
		if ($$dirty.intersected || $$dirty.src || $$dirty.placeholder) { $$invalidate('path', path = intersected ? src : placeholder); }
	};

	return {
		placeholder,
		src,
		alt,
		imgElement,
		path,
		loaded,
		handleLoad,
		img_binding
	};
}

class Index extends SvelteComponent {
	constructor(options) {
		super();
		init(this, options, instance, create_fragment, safe_not_equal, ["placeholder", "src", "alt"]);
	}
}

export default Index;
